﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exemple : Les classes dynamiques
# Fichier : AjouterUnTelephone.fla
# Classe :  Personne.as
*/


package {
	// Définition de la classe dynamique Personne
	public dynamic class Personne {
       	// Définition des attributs de la classe
		public var prenom:String;
		public var nom:String;
		public var dateNaissance:Date;
       	// la variable static est utilisée pour compter le nombre de personnes créées
        public static var compteur:Number= 0;
	
  		// Définition de la fonction constructeur 
   		public function Personne( p:String, n:String, j:Number, m:Number, a:Number) {
	  		prenom = p;
	  		nom = n
	  		dateNaissance = new Date(a, m, j);
          	// compteur est incrémenté de 1 à chaque fois que le constructeur est appelé
          	compteur++;
   		}


  		// Définition du comportement sePresente()
  		public function sePresente():String {
	 	 	var age:Number = getAge()
	  		return "Je m'appelle " + prenom + " " + nom + "\nJ'ai " +age + " ans ";
  		}
	
  		// Définition de la méthode calculant l’âge de la personne
  		public function getAge():Number {
    			var aujourdHui:Date = new Date();
    			var age:Number = aujourdHui.getFullYear() - dateNaissance.getFullYear();
    			return age;
  		}
	}
}
