﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exemple : L'héritage
# Fichier : CreerDesLecteurs.fla
# Classe :  Lecteur.as
*/

//Définition de la classe Lecteur à partir de la classe Personne
package {
	// La classe Lecteur hérite de la classe Personne
	public class Lecteur extends Personne {

		// Définition des attributs de la classe
		private var numAbonne:String;
		private var listeLivres:Array;
		// Récupérer le numéro de l'abonné
		public function getNumAbonne():String {
			return numAbonne;
		}
		// Récupérer la liste de livres
		public function getListeLivres():Array {
			return listeLivres;
		}
		// Modifier le numéro de l'abonné
		public function setNumAbonne(n:String):void {
			numAbonne = n;
		}
		// mettre à jour la liste des livres
		public function setListeLivres(l1:String, l2:String, l3:String):void {
			listeLivres = new Array(l1, l2, l3);
		}
		// Le constructeur de la classe Lecteur 
		public function Lecteur( p:String, n:String, dn:String, num:String, l1:String,l2:String, l3:String) {
			// fait appel au constructeur de la classe supérieure (Personne)
			super(p, n ,dn);
			// initialisation du numéro de l'abonné
			setNumAbonne(num);
			// mise à jour de la liste des livres
			setListeLivres(l1, l2, l3);
		}

		// Définition du comportement sePresente()
		// La méthode sePrésente() écrase (override) le comportement sePresente de la classe supérieure
		override public function sePresente():String {
			// récupère les infos concernant une personne 
			var annonce:String = super.sePresente();
			// ajoute les infos concernant le numéro d'abonné et la liste des livres empruntés
			annonce+= "\nNuméro : " + numAbonne ;
			annonce += "\nListe des livres empruntés : ";
			for (var i:Number = 0; i < listeLivres.length; i++) {
				annonce += "\n\t"+listeLivres[i];
			}
			return annonce;
		}
	}
}