﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exemple : L'héritage
# Fichier : CreerDesLecteurs.fla
# Classe :  Personne.as 
*/


package {
	// Définition de la classe Personne
	public class Personne {
		// Définition des attributs de la classe
		private var prenom:String;
		private var nom:String;
		private var dateNaissance:Date;


		// Définition de la fonction constructeur 
		public function Personne( p:String, n:String, dn:String) {
			setNom(n);
			setPrenom(p);
			setDateNaissance(dn);
		}


		// Définition du comportement sePresente()
		public function sePresente():String {
			var age:Number = getAge();
			return "Je m'appelle " + prenom + " " + nom + "\nJ'ai " + age + " ans ";
		}
		// Définition de la méthode calculant l’âge de la personne
		public function getAge():Number {
			var aujourdHui:Date = new Date();
			var age:Number = 
			    aujourdHui.getFullYear() - dateNaissance.getFullYear();
			return age;
		}

		//  Méthode d’accès en lecture (get)
		//  récupérer le prénom
		public function getPrenom():String {
			return prenom;
		}
		//  récupérer le nom
		public function getNom():String {
			return nom;
		}
		//  récupérer la date de naissance
		public function getDateNaissance():String {
			return dateNaissance.getDate() + "/" + dateNaissance.getMonth() + "/" + dateNaissance.getFullYear();
		}
		//  Méthode d’accès en écriture (set)
		//  Modifier le prénom
		public function setPrenom(p:String):void {
			prenom = p;
		}
		// Modifier le nom
		public function setNom(n:String):void {
			nom = n;
		}
		// Modifier la date de naissance apres validation 
		public function setDateNaissance(dn:String):void {
			var tmp:Array=new Array();
			tmp = dn.split("/",3);
			dateNaissance = new Date(tmp[2], tmp[1], tmp[0]);
			if ( ! valideDateNaissance()) {
				dateNaissance = new Date();
			}
		}

		// Méthode invisible (métier) pour vérifier la validité de la date de naissance
		private function valideDateNaissance():Boolean {
			var aujourdHui:Date = new Date();
			var cetteAnnee:Number  = aujourdHui.getFullYear();
			var anneeNaissance:Number = dateNaissance.getFullYear();
			if (cetteAnnee  < anneeNaissance) {
				return false;
			} else {
				return true;
			}

		}
	}
}