﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet
# Exercice : Un menu déroulant
# Fichier : Exercice 9_8.fla
# Classe : Menu.as
*/


package {
	import flash.display.*;
	import flash.events.*;
	//Définition de la classe Menu extends Sprite
	public class Menu extends Sprite {
		// Définition des attributs de la classe
		private var entete:ItemMenuClp;
		private var listeItems:Array;
		public var estVisible:Boolean = false;
		private var clicSurEntete:Boolean = false;


		private function aDerouler(nbr:Number):void {
			var x:Number =  entete.x;
			var y:Number =  entete.y;
			var h:Number =  entete.height;
			for (var i:uint = 0; i < nbr; i++) {
				listeItems[i].afficher(h*(i+1)+y );
			}
		}

		private function aEnrouler(nbr:Number):void {
			var x:Number =  entete.x;
			var y:Number =  entete.y;
			var h:Number =  entete.height;
			for (var i:uint = 0; i < nbr; i++) {
				listeItems[i].effacer(y);
			}
		}

		private function ajouterUnItem(rubrique:Array, num:uint):void {
			var x:Number =  entete.x;
			var y:Number =  entete.y;
			var h:Number =  entete.height;
			var nvelItem:Item = new Item( x,y, rubrique);
			addChildAt(nvelItem,0);
			listeItems.push(nvelItem);
		}

		public function Menu(nom:String,  nx:Number, ny:Number, l:Array) {
			var nbRubrique:Number = l.length;
			entete = new ItemMenuClp();
			entete.x = nx;
			entete.y = ny;
			entete.labelOut.text = nom;
			addChildAt(entete,0);
			listeItems = new Array();
			for (var i:uint = 0; i < nbRubrique; i++) {
				ajouterUnItem(l[i], i);
			}
			entete.addEventListener(MouseEvent.MOUSE_OVER, auSurvol);
			entete.addEventListener(MouseEvent.MOUSE_OUT, alExterieur);
			entete.addEventListener(MouseEvent.MOUSE_UP, auClic);

			// a. l'entête écoute l'événement lié au focus de la souris
			entete.addEventListener(FocusEvent.FOCUS_OUT, unClicAilleurs);

		}

		// a. Si l'entete perd le focus, le menu est enroulé, le drapeau estVisible est remis à false
		private function unClicAilleurs(e:FocusEvent):void {
			var nbRubrique:Number = listeItems.length;
			aEnrouler(nbRubrique);
			entete.estVisible = false;
		}
		private function auSurvol(e:MouseEvent):void {
			entete.alpha = 0.4;
		}
		private function alExterieur(e:MouseEvent):void {
			entete.alpha = 1;
		}

		private function auClic(e:MouseEvent):void {
			var nbRubrique:Number = listeItems.length;
			if ( !entete.estVisible) {
				aDerouler(nbRubrique);
				entete.estVisible = true;
			} else {
				aEnrouler(nbRubrique);
				entete.estVisible = false;
			}
		}
	}
}